/**
* Copyright (c) 2018 The Nuinalp Authors. All rights reserved.
* Use of this source code is governed by a BSD-style license that can be
* found in the LICENSE file.
*/

$siwtch-margin-edge: 4px;
$switch-width: 22px;
$switch-height: 12px;

$switch-before-size: 20px;
$switch-before-full-width: $switch-width + $siwtch-margin-edge;

.nv-switch {
  display: inline-block;
  height: 34px;
  position: relative;
  width: 50px;

  label {
    display: inline-block;
    height: 100%;
    margin-bottom: 4px;
    position: relative;
    width: 100%;
  }

  input {
    display: none;
    height: 0;
    opacity: 0;
    outline: none;
    visibility: hidden;
    width: 0;
  }

  &.nv-switch-disabled {
    opacity: 0.55;
  }

  .nv-slider {
    border-radius: 20px;
    bottom: 0;
    cursor: pointer;
    height: 28px;
    left: 0;
    overflow: hidden;
    position: absolute;
    right: 0;
    top: 50%;
    transform: translateY(-50%);

    &::before {
      animation: switchOff cubic-bezier(0.76, 0, 0.16, 1.01) 200ms;
      animation-fill-mode: forwards;
      background-color: $white;
      box-shadow: 0 0 0 10px var(--nv-theme-gray);
      content: '';
      height: $switch-before-size;
      left: $siwtch-margin-edge;
      margin-top: -($switch-before-size / 2);
      position: absolute;
      top: 50%;
      transition: cubic-bezier(0.76, 0, 0.16, 1.01) 200ms;
      width: $switch-before-size;
      z-index: 2;
    }

    &::after {
      background-color: var(--nv-theme-gray);
      content: '';
      height: 100%;
      left: 0;
      opacity: 0.7;
      pointer-events: none;
      position: absolute;
      top: 0;
      width: 100%;
      z-index: 0;
    }
  }


  input:checked + .nv-slider::after {
    background-color: var(--nv-theme-primary);
  }

  input:checked + .nv-slider::before {
    box-shadow: 0 0 0 10px var(--nv-theme-primary);
  }

  input:focus + .nv-slider {
    box-shadow: 0 0 1px var(--nv-theme-primary);
  }

  input:checked + .nv-slider::before {
    animation: switchOn cubic-bezier(0.76, 0, 0.16, 1.01) 200ms;
    animation-fill-mode: forwards;
    left: unset;
    right: $siwtch-margin-edge;
  }

  .nv-slider::before {
    border-radius: 50%;
  }
}

@keyframes switchOn {
  from {
    width: $switch-before-full-width;
  }

  to {
    width: $switch-before-size;
  }
}


@keyframes switchOff {
  from {
    right: $siwtch-margin-edge;
    width: $switch-before-full-width;
  }

  to {
    left: $siwtch-margin-edge;
    width: $switch-before-size;
  }
}
